# DBaaS Kafka


<style>
  span[class^="pill-"] {
    color: white;
    padding: 2px 12px;
    border-radius: 12px;
    font-size: 0.6em;
    vertical-align: middle;
    margin-right: 12px;
    font-family: sans-serif;
    font-weight: bold;
    display: inline-block;
    line-height: 1;
  }
  span.pill-GET { background-color: #61affe; }
  span.pill-POST { background-color: #49cc90; }
  span.pill-PUT { background-color: #fca130; }
  span.pill-DELETE { background-color: #f93e3e; }
  span.pill-PATCH { background-color: #50e3c2; }
  span[class^="pill-"]:after {
    content: attr(data-label);
    font-size: 0.9rem;
  }
</style>

Kafka is a distributed, open-source data platform for optimized real-time processing of streaming data.

[Read more](https://community.exoscale.com/product/dbaas/service-specific/kafka/)

## <span data-label="POST" class="pill-POST"></span>create-dbaas-kafka-schema-registry-acl-config

Add a Kafka Schema Registry ACL entry

```
POST /dbaas-kafka/{name}/schema-registry/acl-config
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `permission` | string | **yes** | Kafka Schema Registry permission<br/><br/>Allowed values: `schema_registry_read`, `schema_registry_write`. |
| `resource` | string | **yes** | Kafka Schema Registry name or pattern<br/><br/>Min length: `1`. Max length: `249`. |
| `username` | string | **yes** | Kafka username or username pattern<br/><br/>Min length: `1`. Max length: `64`. |
| `id` | string | no | Kafka ACL ID<br/><br/>Min length: `1`. Max length: `40`. |

<details>
<summary>Example</summary>

```json
{
  "id": "string",
  "permission": "schema_registry_read",
  "resource": "string",
  "username": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-kafka-schema-registry-acl-config`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASKafkaSchemaRegistryAclConfig) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_kafka_schema_registry_acl_config) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasKafkaSchemaRegistryAclConfig(java.lang.String,com.exoscale.sdk.model.CreateDbaasKafkaSchemaRegistryAclConfigRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-kafka-schema-registry-acl-config`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-kafka-schema-registry-acl-config

Delete a Kafka ACL entry

```
DELETE /dbaas-kafka/{name}/schema-registry/acl-config/{acl-id}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |
| `acl-id` | `path` | Min length: `1`. Max length: `40`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-kafka-schema-registry-acl-config`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASKafkaSchemaRegistryAclConfig) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_kafka_schema_registry_acl_config) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasKafkaSchemaRegistryAclConfig(java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-kafka-schema-registry-acl-config`

## <span data-label="POST" class="pill-POST"></span>create-dbaas-kafka-topic-acl-config

Add a Kafka topic ACL entry

```
POST /dbaas-kafka/{name}/topic/acl-config
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `permission` | string | **yes** | Kafka permission<br/><br/>Allowed values: `admin`, `read`, `readwrite`, `write`. |
| `topic` | string | **yes** | Kafka topic name or pattern<br/><br/>Min length: `1`. Max length: `249`. |
| `username` | string | **yes** | Kafka username or username pattern<br/><br/>Min length: `1`. Max length: `64`. |
| `id` | string | no | Kafka ACL ID<br/><br/>Min length: `1`. Max length: `40`. |

<details>
<summary>Example</summary>

```json
{
  "id": "string",
  "permission": "admin",
  "topic": "string",
  "username": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-kafka-topic-acl-config`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASKafkaTopicAclConfig) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_kafka_topic_acl_config) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasKafkaTopicAclConfig(java.lang.String,com.exoscale.sdk.model.CreateDbaasKafkaTopicAclConfigRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-kafka-topic-acl-config`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-kafka-topic-acl-config

Delete a Kafka ACL entry

```
DELETE /dbaas-kafka/{name}/topic/acl-config/{acl-id}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |
| `acl-id` | `path` | Min length: `1`. Max length: `40`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-kafka-topic-acl-config`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASKafkaTopicAclConfig) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_kafka_topic_acl_config) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasKafkaTopicAclConfig(java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-kafka-topic-acl-config`

## <span data-label="POST" class="pill-POST"></span>create-dbaas-kafka-user

Create a DBaaS Kafka user

```
POST /dbaas-kafka/{service-name}/user
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `username` | string | **yes** | Username<br/><br/>Min length: `1`. Max length: `64`. |

<details>
<summary>Example</summary>

```json
{
  "username": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-kafka-user`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASKafkaUser) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_kafka_user) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasKafkaUser(java.lang.String,com.exoscale.sdk.model.CreateDbaasKafkaUserRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-kafka-user`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-kafka-user

Delete a DBaaS kafka user

```
DELETE /dbaas-kafka/{service-name}/user/{username}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |
| `username` | `path` | Min length: `1`. Max length: `64`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-kafka-user`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASKafkaUser) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_kafka_user) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasKafkaUser(java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-kafka-user`

## <span data-label="GET" class="pill-GET"></span>reveal-dbaas-kafka-user-password

Reveal the secrets of a DBaaS Kafka user

```
GET /dbaas-kafka/{service-name}/user/{username}/password/reveal
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |
| `username` | `path` | Min length: `1`. Max length: `64`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `access-cert` | string | Kafka certificate |
| `access-cert-expiry` | string | ISO 8601 date-time. |
| `access-key` | string | Kafka access key |
| `password` | string | Kafka password |
| `username` | string | Kafka username |

<details>
<summary>Example output</summary>

```json
{
  "access-cert": "string",
  "access-cert-expiry": "2024-01-01T12:00:00Z",
  "access-key": "string",
  "password": "string",
  "username": "string"
}
```
</details>


SDK reference for `reveal-dbaas-kafka-user-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RevealDBAASKafkaUserPassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reveal_dbaas_kafka_user_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#revealDbaasKafkaUserPassword(java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api reveal-dbaas-kafka-user-password`

## <span data-label="PUT" class="pill-PUT"></span>reset-dbaas-kafka-user-password

Reset the credentials of a DBaaS Kafka user

```
PUT /dbaas-kafka/{service-name}/user/{username}/password/reset
```

If no password is provided one will be generated automatically.

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |
| `username` | `path` | Min length: `1`. Max length: `64`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `password` | string | no | New password<br/><br/>Min length: `8`. Max length: `256`. |

<details>
<summary>Example</summary>

```json
{
  "password": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `reset-dbaas-kafka-user-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResetDBAASKafkaUserPassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reset_dbaas_kafka_user_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resetDbaasKafkaUserPassword(java.lang.String,java.lang.String,com.exoscale.sdk.model.ResetDbaasKafkaUserPasswordRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api reset-dbaas-kafka-user-password`

## <span data-label="POST" class="pill-POST"></span>create-dbaas-service-kafka

Create a DBaaS Kafka service

```
POST /dbaas-kafka/{name}
```

Create a DBaaS Kafka service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `plan` | string | **yes** | Subscription plan<br/><br/>Min length: `1`. Max length: `128`. |
| `authentication-methods` | [Authentication Methods](#authentication-methods) | no | Kafka authentication methods |
| `ip-filter` | array[string] | no | Allow incoming connections from CIDR address block, e.g. '10.20.0.0/16' |
| `kafka-connect-enabled` | boolean | no | Allow clients to connect to kafka_connect from the public internet for service nodes that are in a project VPC or another type of private network |
| `kafka-connect-settings` | [Kafka Connect configuration values](/reference/api/_schemas/json-schema-kafka-connect/) | no | Kafka Connect configuration values |
| `kafka-rest-enabled` | boolean | no | Enable Kafka-REST service |
| `kafka-rest-settings` | [Kafka REST configuration](/reference/api/_schemas/json-schema-kafka-rest/) | no | Kafka REST configuration |
| `kafka-settings` | [Kafka broker configuration values](/reference/api/_schemas/json-schema-kafka/) | no | Kafka-specific settings |
| `maintenance` | [Maintenance](#maintenance) | no | Automatic maintenance settings |
| `schema-registry-enabled` | boolean | no | Enable Schema-Registry service |
| `schema-registry-settings` | [Schema Registry configuration](/reference/api/_schemas/json-schema-schema-registry/) | no | Schema Registry configuration |
| `termination-protection` | boolean | no | Service is protected against termination and powering off |
| `version` | string | no | Kafka major version<br/><br/>Min length: `1`. |

<details>
<summary>Example</summary>

```json
{
  "authentication-methods": {
    "certificate": true,
    "sasl": true
  },
  "ip-filter": [
    "string"
  ],
  "kafka-connect-enabled": true,
  "kafka-connect-settings": {
    "connector_client_config_override_policy": "None",
    "consumer_auto_offset_reset": "earliest",
    "consumer_fetch_max_bytes": 0,
    "consumer_isolation_level": "read_uncommitted",
    "consumer_max_partition_fetch_bytes": 0,
    "consumer_max_poll_interval_ms": 0,
    "consumer_max_poll_records": 0,
    "offset_flush_interval_ms": 0,
    "offset_flush_timeout_ms": 0,
    "producer_batch_size": 0,
    "producer_buffer_memory": 0,
    "producer_compression_type": "gzip",
    "producer_linger_ms": 0,
    "producer_max_request_size": 0,
    "scheduled_rebalance_max_delay_ms": 0,
    "session_timeout_ms": 0
  },
  "kafka-rest-enabled": true,
  "kafka-rest-settings": {
    "consumer_enable_auto_commit": true,
    "consumer_request_max_bytes": 0,
    "consumer_request_timeout_ms": 0,
    "name_strategy": "topic_name",
    "name_strategy_validation": true,
    "producer_acks": "all",
    "producer_compression_type": "gzip",
    "producer_linger_ms": 0,
    "producer_max_request_size": 0,
    "simpleconsumer_pool_size_max": 0
  },
  "kafka-settings": {
    "auto_create_topics_enable": true,
    "compression_type": "gzip",
    "connections_max_idle_ms": 0,
    "default_replication_factor": 0,
    "group_initial_rebalance_delay_ms": 0,
    "group_max_session_timeout_ms": 0,
    "group_min_session_timeout_ms": 0,
    "log-cleanup-and-compaction": {
      "log_cleaner_delete_retention_ms": 0,
      "log_cleaner_max_compaction_lag_ms": 0,
      "log_cleaner_min_cleanable_ratio": 0,
      "log_cleaner_min_compaction_lag_ms": 0,
      "log_cleanup_policy": "delete"
    },
    "log_flush_interval_messages": 0,
    "log_flush_interval_ms": 0,
    "log_index_interval_bytes": 0,
    "log_index_size_max_bytes": 0,
    "log_local_retention_bytes": 0,
    "log_local_retention_ms": 0,
    "log_message_downconversion_enable": true,
    "log_message_timestamp_difference_max_ms": 0,
    "log_message_timestamp_type": "CreateTime",
    "log_preallocate": true,
    "log_retention_bytes": 0,
    "log_retention_hours": 0,
    "log_retention_ms": 0,
    "log_roll_jitter_ms": 0,
    "log_roll_ms": 0,
    "log_segment_bytes": 0,
    "log_segment_delete_delay_ms": 0,
    "max_connections_per_ip": 0,
    "max_incremental_fetch_session_cache_slots": 0,
    "message_max_bytes": 0,
    "min_insync_replicas": 0,
    "num_partitions": 0,
    "offsets_retention_minutes": 0,
    "producer_purgatory_purge_interval_requests": 0,
    "replica_fetch_max_bytes": 0,
    "replica_fetch_response_max_bytes": 0,
    "sasl_oauthbearer_expected_audience": "string",
    "sasl_oauthbearer_expected_issuer": "string",
    "sasl_oauthbearer_jwks_endpoint_url": "string",
    "sasl_oauthbearer_sub_claim_name": "string",
    "socket_request_max_bytes": 0,
    "transaction_partition_verification_enable": true,
    "transaction_remove_expired_transaction_cleanup_interval_ms": 0,
    "transaction_state_log_segment_bytes": 0
  },
  "maintenance": {
    "dow": "saturday",
    "time": "string"
  },
  "plan": "string",
  "schema-registry-enabled": true,
  "schema-registry-settings": {
    "leader_eligibility": true,
    "topic_name": "_schemas"
  },
  "termination-protection": true,
  "version": "string"
}
```
</details>


### Authentication Methods {#authentication-methods}

Kafka authentication methods

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `certificate` | boolean | no | Enable certificate/SSL authentication |
| `sasl` | boolean | no | Enable SASL authentication |

### Maintenance {#maintenance}

Automatic maintenance settings

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `dow` | string | **yes** | Day of week for installing updates<br/><br/>Allowed values: `saturday`, `tuesday`, `never`, `wednesday`, `sunday`, `friday`, `monday`, `thursday`. |
| `time` | string | **yes** | Time for installing updates, UTC<br/><br/>Min length: `8`. Max length: `8`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-service-kafka`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASServiceKafka) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_service_kafka) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasServiceKafka(java.lang.String,com.exoscale.sdk.model.CreateDbaasServiceKafkaRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-service-kafka`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-service-kafka

Get a DBaaS Kafka service

```
GET /dbaas-kafka/{name}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `authentication-methods` | [Authentication Methods](/reference/api/_schemas/dbaas-service-kafka/#authentication-methods) | Kafka authentication methods |
| `backups` | array of [List of backups for the service](/reference/api/_schemas/dbaas-service-backup/) | List of backups for the service |
| `components` | array of [Components](/reference/api/_schemas/dbaas-service-kafka/#components) | Service component information objects |
| `connection-info` | [Connection Info](/reference/api/_schemas/dbaas-service-kafka/#connection-info) | Kafka connection information properties |
| `created-at` | string | Service creation timestamp (ISO 8601)<br/><br/>ISO 8601 date-time. |
| `disk-size` | integer | TODO UNIT disk space for data storage<br/><br/>Min: `0`. |
| `integrations` | array of [DBaaS Integration](/reference/api/_schemas/dbaas-integration/) | Service integrations |
| `ip-filter` | array[string] | Allow incoming connections from CIDR address block, e.g. '10.20.0.0/16' |
| `kafka-connect-enabled` | boolean | Whether Kafka Connect is enabled |
| `kafka-connect-settings` | [Kafka Connect configuration values](/reference/api/_schemas/json-schema-kafka-connect/) | Kafka Connect configuration values |
| `kafka-rest-enabled` | boolean | Whether Kafka REST is enabled |
| `kafka-rest-settings` | [Kafka REST configuration](/reference/api/_schemas/json-schema-kafka-rest/) | Kafka REST configuration |
| `kafka-settings` | [Kafka broker configuration values](/reference/api/_schemas/json-schema-kafka/) | Kafka-specific settings |
| `maintenance` | [Automatic maintenance settings](/reference/api/_schemas/dbaas-service-maintenance/) | Automatic maintenance settings |
| `name` | string | Service name<br/><br/>Min length: `0`. Max length: `63`. |
| `node-count` | integer | Number of service nodes in the active plan<br/><br/>Min: `0`. |
| `node-cpu-count` | integer | Number of CPUs for each node<br/><br/>Min: `0`. |
| `node-memory` | integer | TODO UNIT of memory for each node<br/><br/>Min: `0`. |
| `node-states` | array of [Automatic maintenance settings](/reference/api/_schemas/dbaas-node-state/) | State of individual service nodes |
| `notifications` | array of [Service notifications](/reference/api/_schemas/dbaas-service-notification/) | Service notifications |
| `plan` | string | Subscription plan |
| `prometheus-uri` | [Prometheus URI](/reference/api/_schemas/dbaas-service-kafka/#prometheus-uri) | Prometheus integration URI |
| `schema-registry-enabled` | boolean | Whether Schema-Registry is enabled |
| `schema-registry-settings` | [Schema Registry configuration](/reference/api/_schemas/json-schema-schema-registry/) | Schema Registry configuration |
| `state` | string | State of the service<br/><br/>Allowed values: `running`, `rebuilding`, `rebalancing`, `poweroff`. |
| `termination-protection` | boolean | Service is protected against termination and powering off |
| `type` | string | Service type code<br/><br/>Min length: `0`. Max length: `64`. |
| `updated-at` | string | Service last update timestamp (ISO 8601)<br/><br/>ISO 8601 date-time. |
| `uri` | string | URI for connecting to the service (may be absent) |
| `uri-params` | object | service_uri parameterized into key-value pairs |
| `users` | array of [Users](/reference/api/_schemas/dbaas-service-kafka/#users) | List of service users |
| `version` | string | Kafka version |
| `zone` | string | The zone where the service is running |

<details>
<summary>Example output</summary>

```json
{
  "authentication-methods": {
    "certificate": true,
    "sasl": true
  },
  "backups": [
    {
      "backup-name": "string",
      "backup-time": "2024-01-01T12:00:00Z",
      "data-size": 0
    }
  ],
  "components": [
    {
      "component": "string",
      "host": "string",
      "kafka-authentication-method": "certificate",
      "port": 0,
      "route": "dynamic",
      "usage": "primary"
    }
  ],
  "connection-info": {
    "access-cert": "string",
    "access-key": "string",
    "connect-uri": "string",
    "nodes": [
      "string"
    ],
    "registry-uri": "string",
    "rest-uri": "string"
  },
  "created-at": "2024-01-01T12:00:00Z",
  "disk-size": 0,
  "integrations": [
    {
      "description": "string",
      "dest": "string",
      "id": "string",
      "is-active": true,
      "is-enabled": true,
      "settings": {},
      "source": "string",
      "status": "string",
      "type": "string"
    }
  ],
  "ip-filter": [
    "string"
  ],
  "kafka-connect-enabled": true,
  "kafka-connect-settings": {
    "connector_client_config_override_policy": "None",
    "consumer_auto_offset_reset": "earliest",
    "consumer_fetch_max_bytes": 0,
    "consumer_isolation_level": "read_uncommitted",
    "consumer_max_partition_fetch_bytes": 0,
    "consumer_max_poll_interval_ms": 0,
    "consumer_max_poll_records": 0,
    "offset_flush_interval_ms": 0,
    "offset_flush_timeout_ms": 0,
    "producer_batch_size": 0,
    "producer_buffer_memory": 0,
    "producer_compression_type": "gzip",
    "producer_linger_ms": 0,
    "producer_max_request_size": 0,
    "scheduled_rebalance_max_delay_ms": 0,
    "session_timeout_ms": 0
  },
  "kafka-rest-enabled": true,
  "kafka-rest-settings": {
    "consumer_enable_auto_commit": true,
    "consumer_request_max_bytes": 0,
    "consumer_request_timeout_ms": 0,
    "name_strategy": "topic_name",
    "name_strategy_validation": true,
    "producer_acks": "all",
    "producer_compression_type": "gzip",
    "producer_linger_ms": 0,
    "producer_max_request_size": 0,
    "simpleconsumer_pool_size_max": 0
  },
  "kafka-settings": {
    "auto_create_topics_enable": true,
    "compression_type": "gzip",
    "connections_max_idle_ms": 0,
    "default_replication_factor": 0,
    "group_initial_rebalance_delay_ms": 0,
    "group_max_session_timeout_ms": 0,
    "group_min_session_timeout_ms": 0,
    "log-cleanup-and-compaction": {
      "log_cleaner_delete_retention_ms": 0,
      "log_cleaner_max_compaction_lag_ms": 0,
      "log_cleaner_min_cleanable_ratio": 0,
      "log_cleaner_min_compaction_lag_ms": 0,
      "log_cleanup_policy": "delete"
    },
    "log_flush_interval_messages": 0,
    "log_flush_interval_ms": 0,
    "log_index_interval_bytes": 0,
    "log_index_size_max_bytes": 0,
    "log_local_retention_bytes": 0,
    "log_local_retention_ms": 0,
    "log_message_downconversion_enable": true,
    "log_message_timestamp_difference_max_ms": 0,
    "log_message_timestamp_type": "CreateTime",
    "log_preallocate": true,
    "log_retention_bytes": 0,
    "log_retention_hours": 0,
    "log_retention_ms": 0,
    "log_roll_jitter_ms": 0,
    "log_roll_ms": 0,
    "log_segment_bytes": 0,
    "log_segment_delete_delay_ms": 0,
    "max_connections_per_ip": 0,
    "max_incremental_fetch_session_cache_slots": 0,
    "message_max_bytes": 0,
    "min_insync_replicas": 0,
    "num_partitions": 0,
    "offsets_retention_minutes": 0,
    "producer_purgatory_purge_interval_requests": 0,
    "replica_fetch_max_bytes": 0,
    "replica_fetch_response_max_bytes": 0,
    "sasl_oauthbearer_expected_audience": "string",
    "sasl_oauthbearer_expected_issuer": "string",
    "sasl_oauthbearer_jwks_endpoint_url": "string",
    "sasl_oauthbearer_sub_claim_name": "string",
    "socket_request_max_bytes": 0,
    "transaction_partition_verification_enable": true,
    "transaction_remove_expired_transaction_cleanup_interval_ms": 0,
    "transaction_state_log_segment_bytes": 0
  },
  "maintenance": {
    "dow": "saturday",
    "time": "string",
    "updates": [
      {
        "deadline": "2024-01-01T12:00:00Z",
        "description": "string",
        "start-after": "2024-01-01T12:00:00Z",
        "start-at": "2024-01-01T12:00:00Z"
      }
    ]
  },
  "name": "string",
  "node-count": 0,
  "node-cpu-count": 0,
  "node-memory": 0,
  "node-states": [
    {
      "name": "string",
      "progress-updates": [
        {
          "completed": true,
          "current": 0,
          "max": 0,
          "min": 0,
          "phase": "stream",
          "unit": "string"
        }
      ],
      "role": "standby",
      "state": "leaving"
    }
  ],
  "notifications": [
    {
      "level": "warning",
      "message": "string",
      "metadata": {},
      "type": "service_powered_off_removal"
    }
  ],
  "plan": "string",
  "prometheus-uri": {
    "host": "string",
    "port": 0
  },
  "schema-registry-enabled": true,
  "schema-registry-settings": {
    "leader_eligibility": true,
    "topic_name": "_schemas"
  },
  "state": "running",
  "termination-protection": true,
  "type": "string",
  "updated-at": "2024-01-01T12:00:00Z",
  "uri": "string",
  "uri-params": {},
  "users": [
    {
      "access-cert": "string",
      "access-cert-expiry": "2024-01-01T12:00:00Z",
      "access-key": "string",
      "password": "string",
      "type": "string",
      "username": "string"
    }
  ],
  "version": "string",
  "zone": "string"
}
```
</details>


SDK reference for `get-dbaas-service-kafka`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASServiceKafka) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_service_kafka) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasServiceKafka(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-service-kafka`

## <span data-label="PUT" class="pill-PUT"></span>update-dbaas-service-kafka

Update a DBaaS Kafka service

```
PUT /dbaas-kafka/{name}
```

Update a DBaaS Kafka service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `authentication-methods` | [Authentication Methods](#authentication-methods) | no | Kafka authentication methods |
| `ip-filter` | array[string] | no | Allow incoming connections from CIDR address block, e.g. '10.20.0.0/16' |
| `kafka-connect-enabled` | boolean | no | Allow clients to connect to kafka_connect from the public internet for service nodes that are in a project VPC or another type of private network |
| `kafka-connect-settings` | [Kafka Connect configuration values](/reference/api/_schemas/json-schema-kafka-connect/) | no | Kafka Connect configuration values |
| `kafka-rest-enabled` | boolean | no | Enable Kafka-REST service |
| `kafka-rest-settings` | [Kafka REST configuration](/reference/api/_schemas/json-schema-kafka-rest/) | no | Kafka REST configuration |
| `kafka-settings` | [Kafka broker configuration values](/reference/api/_schemas/json-schema-kafka/) | no | Kafka-specific settings |
| `maintenance` | [Maintenance](#maintenance) | no | Automatic maintenance settings |
| `plan` | string | no | Subscription plan<br/><br/>Min length: `1`. Max length: `128`. |
| `schema-registry-enabled` | boolean | no | Enable Schema-Registry service |
| `schema-registry-settings` | [Schema Registry configuration](/reference/api/_schemas/json-schema-schema-registry/) | no | Schema Registry configuration |
| `termination-protection` | boolean | no | Service is protected against termination and powering off |
| `version` | string | no | Kafka major version<br/><br/>Min length: `1`. |

<details>
<summary>Example</summary>

```json
{
  "authentication-methods": {
    "certificate": true,
    "sasl": true
  },
  "ip-filter": [
    "string"
  ],
  "kafka-connect-enabled": true,
  "kafka-connect-settings": {
    "connector_client_config_override_policy": "None",
    "consumer_auto_offset_reset": "earliest",
    "consumer_fetch_max_bytes": 0,
    "consumer_isolation_level": "read_uncommitted",
    "consumer_max_partition_fetch_bytes": 0,
    "consumer_max_poll_interval_ms": 0,
    "consumer_max_poll_records": 0,
    "offset_flush_interval_ms": 0,
    "offset_flush_timeout_ms": 0,
    "producer_batch_size": 0,
    "producer_buffer_memory": 0,
    "producer_compression_type": "gzip",
    "producer_linger_ms": 0,
    "producer_max_request_size": 0,
    "scheduled_rebalance_max_delay_ms": 0,
    "session_timeout_ms": 0
  },
  "kafka-rest-enabled": true,
  "kafka-rest-settings": {
    "consumer_enable_auto_commit": true,
    "consumer_request_max_bytes": 0,
    "consumer_request_timeout_ms": 0,
    "name_strategy": "topic_name",
    "name_strategy_validation": true,
    "producer_acks": "all",
    "producer_compression_type": "gzip",
    "producer_linger_ms": 0,
    "producer_max_request_size": 0,
    "simpleconsumer_pool_size_max": 0
  },
  "kafka-settings": {
    "auto_create_topics_enable": true,
    "compression_type": "gzip",
    "connections_max_idle_ms": 0,
    "default_replication_factor": 0,
    "group_initial_rebalance_delay_ms": 0,
    "group_max_session_timeout_ms": 0,
    "group_min_session_timeout_ms": 0,
    "log-cleanup-and-compaction": {
      "log_cleaner_delete_retention_ms": 0,
      "log_cleaner_max_compaction_lag_ms": 0,
      "log_cleaner_min_cleanable_ratio": 0,
      "log_cleaner_min_compaction_lag_ms": 0,
      "log_cleanup_policy": "delete"
    },
    "log_flush_interval_messages": 0,
    "log_flush_interval_ms": 0,
    "log_index_interval_bytes": 0,
    "log_index_size_max_bytes": 0,
    "log_local_retention_bytes": 0,
    "log_local_retention_ms": 0,
    "log_message_downconversion_enable": true,
    "log_message_timestamp_difference_max_ms": 0,
    "log_message_timestamp_type": "CreateTime",
    "log_preallocate": true,
    "log_retention_bytes": 0,
    "log_retention_hours": 0,
    "log_retention_ms": 0,
    "log_roll_jitter_ms": 0,
    "log_roll_ms": 0,
    "log_segment_bytes": 0,
    "log_segment_delete_delay_ms": 0,
    "max_connections_per_ip": 0,
    "max_incremental_fetch_session_cache_slots": 0,
    "message_max_bytes": 0,
    "min_insync_replicas": 0,
    "num_partitions": 0,
    "offsets_retention_minutes": 0,
    "producer_purgatory_purge_interval_requests": 0,
    "replica_fetch_max_bytes": 0,
    "replica_fetch_response_max_bytes": 0,
    "sasl_oauthbearer_expected_audience": "string",
    "sasl_oauthbearer_expected_issuer": "string",
    "sasl_oauthbearer_jwks_endpoint_url": "string",
    "sasl_oauthbearer_sub_claim_name": "string",
    "socket_request_max_bytes": 0,
    "transaction_partition_verification_enable": true,
    "transaction_remove_expired_transaction_cleanup_interval_ms": 0,
    "transaction_state_log_segment_bytes": 0
  },
  "maintenance": {
    "dow": "saturday",
    "time": "string"
  },
  "plan": "string",
  "schema-registry-enabled": true,
  "schema-registry-settings": {
    "leader_eligibility": true,
    "topic_name": "_schemas"
  },
  "termination-protection": true,
  "version": "string"
}
```
</details>


### Authentication Methods {#authentication-methods}

Kafka authentication methods

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `certificate` | boolean | no | Enable certificate/SSL authentication |
| `sasl` | boolean | no | Enable SASL authentication |

### Maintenance {#maintenance}

Automatic maintenance settings

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `dow` | string | **yes** | Day of week for installing updates<br/><br/>Allowed values: `saturday`, `tuesday`, `never`, `wednesday`, `sunday`, `friday`, `monday`, `thursday`. |
| `time` | string | **yes** | Time for installing updates, UTC<br/><br/>Min length: `8`. Max length: `8`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `update-dbaas-service-kafka`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.UpdateDBAASServiceKafka) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.update_dbaas_service_kafka) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#updateDbaasServiceKafka(java.lang.String,com.exoscale.sdk.model.UpdateDbaasServiceKafkaRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api update-dbaas-service-kafka`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-service-kafka

Delete a Kafka service

```
DELETE /dbaas-kafka/{name}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-service-kafka`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASServiceKafka) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_service_kafka) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasServiceKafka(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-service-kafka`


---

## Other Operations

## <span data-label="GET" class="pill-GET"></span>get-dbaas-kafka-acl-config

Get DBaaS kafka ACL configuration

```
GET /dbaas-kafka/{name}/acl-config
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `schema-registry-acl` | array of [DBaaS Kafka Schema Registry Acl Entry](/reference/api/_schemas/dbaas-kafka-schema-registry-acl-entry/) |  |
| `topic-acl` | array of [DBaaS Kafka Topic Acl Entry](/reference/api/_schemas/dbaas-kafka-topic-acl-entry/) |  |

<details>
<summary>Example output</summary>

```json
{
  "schema-registry-acl": [
    {
      "id": "string",
      "permission": "schema_registry_read",
      "resource": "string",
      "username": "string"
    }
  ],
  "topic-acl": [
    {
      "id": "string",
      "permission": "admin",
      "topic": "string",
      "username": "string"
    }
  ]
}
```
</details>


SDK reference for `get-dbaas-kafka-acl-config`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASKafkaAclConfig) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_kafka_acl_config) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasKafkaAclConfig(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-kafka-acl-config`

## <span data-label="GET" class="pill-GET"></span>reveal-dbaas-kafka-connect-password

Reveal the secrets for DBaaS Kafka Connect

```
GET /dbaas-kafka/{service-name}/connect/password/reveal
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `password` | string | Kafka Connect password |
| `username` | string | Kafka Connect username |

<details>
<summary>Example output</summary>

```json
{
  "password": "string",
  "username": "string"
}
```
</details>


SDK reference for `reveal-dbaas-kafka-connect-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RevealDBAASKafkaConnectPassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reveal_dbaas_kafka_connect_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#revealDbaasKafkaConnectPassword(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api reveal-dbaas-kafka-connect-password`

## <span data-label="PUT" class="pill-PUT"></span>start-dbaas-kafka-maintenance

Initiate Kafka maintenance update

```
PUT /dbaas-kafka/{name}/maintenance/start
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `start-dbaas-kafka-maintenance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.StartDBAASKafkaMaintenance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.start_dbaas_kafka_maintenance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#startDbaasKafkaMaintenance(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api start-dbaas-kafka-maintenance`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-settings-kafka

Get DBaaS Kafka settings

```
GET /dbaas-settings-kafka
```

Get DBaaS Kafka settings

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `settings` | [Settings](#settings) |  |

<details>
<summary>Example output</summary>

```json
{
  "settings": {
    "kafka": {
      "additionalProperties": true,
      "properties": {},
      "title": "string",
      "type": "string"
    },
    "kafka-connect": {
      "additionalProperties": true,
      "properties": {},
      "title": "string",
      "type": "string"
    },
    "kafka-rest": {
      "additionalProperties": true,
      "properties": {},
      "title": "string",
      "type": "string"
    },
    "schema-registry": {
      "additionalProperties": true,
      "properties": {},
      "title": "string",
      "type": "string"
    }
  }
}
```
</details>


### Settings {#settings}

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `kafka` | [Kafka](#kafka) | no | Kafka broker configuration values |
| `kafka-connect` | [Kafka Connect](#kafka-connect) | no | Kafka Connect configuration values |
| `kafka-rest` | [Kafka Rest](#kafka-rest) | no | Kafka REST configuration |
| `schema-registry` | [Schema Registry](#schema-registry) | no | Schema Registry configuration |

### Kafka {#kafka}

Kafka broker configuration values

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `additionalProperties` | boolean | no |  |
| `properties` | object | no |  |
| `title` | string | no |  |
| `type` | string | no |  |

### Kafka Connect {#kafka-connect}

Kafka Connect configuration values

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `additionalProperties` | boolean | no |  |
| `properties` | object | no |  |
| `title` | string | no |  |
| `type` | string | no |  |

### Kafka Rest {#kafka-rest}

Kafka REST configuration

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `additionalProperties` | boolean | no |  |
| `properties` | object | no |  |
| `title` | string | no |  |
| `type` | string | no |  |

### Schema Registry {#schema-registry}

Schema Registry configuration

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `additionalProperties` | boolean | no |  |
| `properties` | object | no |  |
| `title` | string | no |  |
| `type` | string | no |  |

SDK reference for `get-dbaas-settings-kafka`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASSettingsKafka) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_settings_kafka) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasSettingsKafka())

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-settings-kafka`


